controllers/EtapaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Etapa;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * EtapaController implements the CRUD actions for Etapa model.
 */
class EtapaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Etapa models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Etapa::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Etapa model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Etapa model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Etapa();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->numetapa]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Etapa model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->numetapa]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Etapa model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Etapa model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Etapa the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Etapa::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/LlevaController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Lleva;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;

/**
 * LlevaController implements the CRUD actions for Lleva model.
 */
class LlevaController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Lleva models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Lleva::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Lleva model.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($numetapa, $código)
    {
        return $this->render('view', [
            'model' => $this->findModel($numetapa, $código),
        ]);
    }

    /**
     * Creates a new Lleva model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Lleva();

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
        }

        return $this->render('create', [
            'model' => $model,
        ]);
    }

    /**
     * Updates an existing Lleva model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($numetapa, $código)
    {
        $model = $this->findModel($numetapa, $código);

        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'numetapa' => $model->numetapa, 'código' => $model->código]);
        }

        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Lleva model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $numetapa
     * @param string $código
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($numetapa, $código)
    {
        $this->findModel($numetapa, $código)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Lleva model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $numetapa
     * @param string $código
     * @return Lleva the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($numetapa, $código)
    {
        if (($model = Lleva::findOne(['numetapa' => $numetapa, 'código' => $código])) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\lleva;
use app\models\Puerto;
use yii\data\ActiveDataProvider;
use yii\data\SqlDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionCrud(){
        return $this->render("gestion");
    }   
     
    public function actionConsulta1(){
        //mediante DAO
        $numero = yii::$app->db
                ->createCommand('SELECT count(distinct edad) FROM ciclista')
                ->queryScalar();
                
           $dataProvider = new SqlDataProvider([
            'sql' => 'SELECT distinct edad FROM ciclista',
            'totalCount' => $numero,
        ]);
        
        
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1 con Dao",
            "enunciado"=>"Listar las edades de los ciclistas (sin repetidos)",
            "sql"=>"select distinct edad from ciclista",
        ]);
    }
    
    
    public function actionConsulta1a(){
        //mediante Active Record
        
         $dataProvider = new ActiveDataProvider([
             'query' => Ciclista::find()
                 ->select("edad")->distinct(),
             'pagination'=>[
                 'pageSize'=>5,
             ]
         ]);

        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas (sin repetidos)",
            "sql"=>"select distinct edad from ciclista",
        ]);
    
      
    }
    public function actionConsulta2(){
        //mediante DAO
        $numero = yii::$app->db
                ->createCommand("SELECT count(distinct edad) From ciclista WHERE nomequipo = 'Artiach'")
                ->queryScalar();
                
           $dataProvider = new SqlDataProvider([
            'sql' => "SELECT DISTINCT edad FROM ciclista WHERE nomequipo = 'Artiach'",
            'totalCount' => $numero,
        ]);
        
        
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1.2 con Dao",
            "enunciado"=>"SELECT DISTINCT edad FROM ciclista WHERE nomequipo = 'Artiach'",
            "sql"=>"select distinct edad from ciclista",
        ]);
    }
    
    public function actionConsulta2a(){
        //mediante Active Record
        
         $dataProvider = new ActiveDataProvider([
             'query' => Ciclista::find()
                 ->select("edad")->distinct()
                 ->where("nomequipo ='Artiach'"),
             'pagination'=>[
                 'pageSize'=>5,
             ]
         ]);

        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1.2 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas del equipo Artiach(sin repetidos)",
            "sql"=>" SELECT DISTINCT edad FROM ciclista WHERE nomequipo = 'Artiach'",
        ]);
    }
    
    
    public function actionConsulta3(){
        //mediante DAO
        $numero = yii::$app->db
                ->createCommand("SELECT count(distinct edad) From ciclista WHERE nomequipo ='Artiach' or nomequipo ='Amore Vita'")
                ->queryScalar();
                
           $dataProvider = new SqlDataProvider([
            'sql' => "SELECT DISTINCT edad FROM ciclista WHERE nomequipo = 'Artiach' OR nomequipo = 'Amore Vita'",
            'totalCount' => $numero,
        ]);
        
        
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1.3 con Dao",
            "enunciado"=>"SELECT DISTINCT edad FROM ciclista WHERE nomequipo = 'Artiach' OR nomequipo = 'Amore Vita'",
            "sql"=>"select distinct edad from ciclista",
        ]);
    }
    
    
    
    public function actionConsulta3a(){
        //mediante Active Record
        
         $dataProvider = new ActiveDataProvider([
             'query' => Ciclista::find()
                 ->select("edad")->distinct()
                 ->where("nomequipo ='Artiach' or nomequipo ='Amore Vita'"),
             'pagination'=>[
                 'pageSize'=>5,
             ]
         ]);

        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['edad'],
            "titulo"=>"Consulta 1.3 con Active Record",
            "enunciado"=>"Listar las edades de los ciclistas del equipo Artiach o Amore vita(sin repetidos)",
            "sql"=>" SELECT DISTINCT edad FROM ciclista WHERE nomequipo = 'Artiach' or nomequipo = 'Amore Vita'",
        ]);
    
      
    }
    
    
     public function actionConsulta4(){
        //mediante DAO
        $numero = yii::$app->db
                ->createCommand("SELECT count(distinct dorsal) From ciclista WHERE edad < 25 OR edad > 30")
                ->queryScalar();
                
           $dataProvider = new SqlDataProvider([
            'sql' => "SELECT DISTINCT dorsal FROM ciclista WHERE edad < 25 OR edad > 30",
            'totalCount' => $numero,
            'pagination' => [
                'pageSize' =>5,
            ],   
        ]);
        
        
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 1.4 con Dao",
            "enunciado"=>"SELECT DISTINCT dorsal FROM ciclista WHERE edad < 25 OR edad > 30",
            "sql"=>"SELECT DISTINCT dorsal FROM ciclista WHERE edad < 25 OR edad > 30",
            
        ]);
    }
    public function actionConsulta4a(){
        //mediante Active Record
        
         $dataProvider = new ActiveDataProvider([
             'query' => Ciclista::find()
                 ->select("dorsal")->distinct()
                 ->where("edad < 25 or edad > 30"),
             'pagination'=>[
                 'pageSize'=>5,
             ]
         ]);

        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 1.4 con Active Record",
            "enunciado"=>"Listar los dorsales de los ciclistas del equipo cuya edad sea menor de 25 o mayor que 30(sin repetidos)",
            "sql"=>"SELECT DISTINCT dorsal FROM ciclista WHERE edad < 25 OR edad > 30",
        ]);
    
      
    }
        public function actionConsulta5(){
        
         //mediante DAO
        $numero = yii::$app->db
                ->createCommand("SELECT count(distinct dorsal) From ciclista WHERE edad between 28 and 32 and nomequipo ='Banesto'")
                ->queryScalar();
                
           $dataProvider = new SqlDataProvider([
            'sql' => "SELECT distinct dorsal From ciclista WHERE edad between 28 and 32 and nomequipo ='Banesto'",
            'totalCount' => $numero,
            'pagination' => [
                'pageSize' =>5,
            ],   
        ]);
        
        
        return $this->render('resultado',[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 1.5 con Dao",
            "enunciado"=>"SELECT distinct dorsal From ciclista WHERE edad between 28 and 32 and nomequipo ='Banesto'",
            "sql"=>"SELECT distinct dorsal From ciclista WHERE edad between 28 and 32 and nomequipo ='Banesto'",
            
        ]);
    
    }
    
    public function actionConsulta5a(){
        //mediante Active Record
        
         $dataProvider = new ActiveDataProvider([
             'query' => Ciclista::find()
                 ->select("dorsal")->distinct()
                 ->where("edad between 28 and 32 and nomequipo ='Banesto'"),
             'pagination'=>[
                 'pageSize'=>5,
             ]
         ]);

        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 1.5 con Active Record",
            "enunciado"=>"Listar los dorsales de los ciclistas cuya edad este entre 28 y 32 y cuyo equipo sea Banesto(sin repetidos)",
            "sql"=>"SELECT DISTINCT dorsal FROM ciclista WHERE edad BETWEEN 28 AND 32 AND nomequipo ='Banesto'",
        ]);
    
    }
     public function actionConsulta6(){
        //mediante Dao
         
        $numero = yii::$app->db

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php
use yii\helpers\Html; 

?>

<?= Html::a('Ciclistas', ['ciclista/index'], ['class' => 'btn btn-primary btn-large']) ?>
<?= Html::a('Equipo', ['equipo/index'], ['class' => 'btn btn-primary btn-large menu_crud']) ?>
<?= Html::a('Etapa', ['etapa/index'], ['class' => 'btn btn-primary btn-large menu_crud']) ?>
<?= Html::a('Lleva', ['lleva/index'], ['class' => 'btn btn-primary btn-large menu_crud']) ?>
<?= Html::a('Maillot', ['maillot/index'], ['class' => 'btn btn-primary btn-large menu_crud']) ?>
<?= Html::a('Puerto', ['puerto/index'], ['class' => 'btn btn-primary btn-large menu_crud']) ?>

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'Consultas de Seleccion 1';
?>
<div class="site-index">

    <div class="jumbotron">
        <h1>Consultas de seleccion 1</h1>

        <p class="lead">Modulo 3 - unidad 2</p>
        
    </div>

    <div class="body-content">
        <div class="row">
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1</h3>
                        <p>Listar las edades de los ciclistas (sin repetidos)</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta1a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta1'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                  </div>
                </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.2</h3>
                        <p>Listar las edades de los ciclistas de Artiach (sin repetidos)</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta2a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta2'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                  </div>
                </div>
            
              
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.3</h3>
                        <p>Listar las edades de los ciclistas de Artiach o de Amore vita(sin repetidos)</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta3a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta3'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.4</h3>
                        <p>Listar los dorsales de los ciclistas cuya edad sea menor que 25 o mayor que 30(sin repetidos)</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta4a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta4'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
            
         
             <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.5</h3>
                        <p>Listar los dorsales de los ciclistas WHERE edad BETWEEN 28 AND 32 AND nomequipo ='Banesto'</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta5a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta5'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
   
            
              <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.6</h3>
                        <p>Listar los nombres de los ciclistas cuyo nombre tenga mas de 6 caracteres</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta6a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta6'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
            
             <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.7</h3>
                        <p>Listar los nombres de los ciclistas en mayusculas y su dorsal</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta7a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta7'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.8</h3>
                        <p>Listar los ciclistas que han llevado el maillot MGE(amarillo) en alguna etapa</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta8a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta8'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
             
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.9</h3>
                        <p>Listar los puertos cuya altura sea mayor que 1500</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta9a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta9'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.10</h3>
                        <p>Dorsal de ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 o cuya altura este entre 1800 y 3000</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta10a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta10'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
            <div class="col-sm-6 col-md-4">
                <div class="thumbnail">
                    <div class="caption">
                        <h3>Consulta 1.11</h3>
                        <p>Dorsal de ciclistas que hayan ganado algun puerto cuya pendiente sea mayor que 8 Y cuya altura este entre 1800 y 3000</p>
                        <p>
                            <?= Html::a('Active Record', ['site/consulta11a'], ['class' => 'btn btn-primary']) ?>
                            <?= Html::a('Dao', ['site/consulta11'], ['class' => 'btn btn-default']) ?>
                        </p>
                    </div>
                </div>
            </div>
            
        </div>
        

    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;

?>
<div class="jumbotron">
    <h3><?= $titulo ?></h3>
    <p class="lead"><?= $enunciado ?></p>   
   <p class="well"><?= $sql ?></p>   
</div>

    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
    ]); ?>